#include <hardware/camera3.h>

int camera_set_callbacks(const camera_module_callbacks_t* callbacks);
int camera_get_camera_info(int cameraId, struct camera_info* info);
int camera_get_number_of_cameras(void);
int camera_device_open(const hw_module_t* module, const char* name, hw_device_t** device);

static struct hw_module_methods_t camera_module_methods = {
    .open = camera_device_open
};

camera_module_t HAL_MODULE_INFO_SYM = {
    .common = {
        .tag                   = HARDWARE_MODULE_TAG,
        .module_api_version    = CAMERA_MODULE_API_VERSION_2_4,
        .hal_api_version       = HARDWARE_HAL_API_VERSION,
        .id                    = CAMERA_HARDWARE_MODULE_ID,
        .name                  = "RealtekCameraHal3",
        .author                = "Realtek",
        .methods               = &camera_module_methods,
        .dso                   = NULL, /* remove compilation warnings */
        .reserved              = {0}, /* remove compilation warnings */
    },
    .get_number_of_cameras      = camera_get_number_of_cameras,
    .get_camera_info            = camera_get_camera_info,
    .set_callbacks              = camera_set_callbacks,
    .get_vendor_tag_ops         = NULL,
    .open_legacy                = NULL,
    .set_torch_mode             = NULL,
    .init                       = NULL,
    .reserved                   = {0}
};
