#ifndef _CAMERA_MONITOR_
#define _CAMERA_MONITOR_

#include <pthread.h>
#include <sysutils/NetlinkEvent.h>
#include "Common.h"
#include "misc.h"

typedef int (*refresh_cameras)();

namespace android_camera_hal3
{

class CameraMonitor
{

public:
    static CameraMonitor* Instance();
    virtual ~CameraMonitor();

    void handleSwitchEvent(NetlinkEvent* evt);
    void onInitialize();
    void setCallback(refresh_cameras cb)
    {
        mCallback = cb;
    }

private:
    CameraMonitor();
    static CameraMonitor* sInstance;

    pthread_t mUeventThread;
    static void* pthread_entry(void* ptr);

    refresh_cameras mCallback;
};

};

#endif
